package org.teiid.web;

import java.util.ArrayList;
import java.util.List;

import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlValue;
import javax.xml.ws.ResponseWrapper;

import org.teiid.web.DepartmentService.Employee.Salary;


@WebService(
	       name="Department",
	       serviceName="DepartmentService",
	       targetNamespace="http://teiid.org"
	   )
@SuppressWarnings("nls")
public class DepartmentService {
	
	@WebMethod(operationName="getdepartment", action = "urn:department")
	@ResponseWrapper(targetNamespace="http://teiid.org", className="org.teiid.web.jaxws.GetDepartmentResponse")
	public Department getDepartment() {
		Department d = new Department();
		d.building = "101";
		
		Employee e1 = new Employee();
		e1.name.firstName = "John";
		e1.name.lastName = "Doe";
		e1.id = "901";
		e1.office = "344";
		e1.salary = new Salary();
		e1.salary.value = "55000";
		d.employees.add(e1);
		
		Employee e2 = new Employee();
		e2.name.firstName = "Perter";
		e2.name.lastName = "Pan";
		e2.id = "902";
		e2.office = "216";
		e2.phone = "905-416-5004";
		
		d.employees.add(e2);		
		
		return d;
	}

	@XmlRootElement(name = "department")
	@XmlAccessorType(XmlAccessType.NONE)
	public static class Department {
		@XmlAttribute(name = "bldg")
		String building;
		
		@XmlElement(name = "employee")
		List<Employee> employees = new ArrayList<Employee>();
	}
	
	@XmlAccessorType(XmlAccessType.NONE)
	public static class Employee {
		
		@XmlAttribute(name = "id")
		String id;
		
		@XmlElement(name = "name")
		Name name = new Name();
		
		@XmlElement(name = "office")
		String office;
		
		@XmlElement(name = "phone")
		String phone;
		@XmlElement(name = "salary")
		Salary salary = null;
		
		@XmlAccessorType(XmlAccessType.NONE)
		static class Name {
			@XmlElement(name = "first")
			String firstName;
			@XmlElement(name = "last")
			String lastName;			
		}
		
		@XmlAccessorType(XmlAccessType.NONE)
		static class Salary {
			@XmlAttribute(name = "currency")
			String currency = "USD";
			@XmlValue
			String value;
		}
	}
}
